max.entropy <- function(bench,X,Y,q,max.counter=100, max.diff=1e-8){
	# Initialize theta
	# Theta is the same size as Y
	theta <- list(length(bench))
	for(i in 1:length(bench)){theta[[i]] <- Y[[i]]*0}
	
	# Calculate X*t(theta)
	x.theta <- matrix(0,nrow=nrow(X[[1]]),ncol=nrow(Y[[i]]))
	for(i in 1:length(bench)){x.theta <- x.theta+X[[i]]%*%t(theta[[i]])}
	p.hat <- q*exp(x.theta)
	p.hat <- p.hat/sum(p.hat)
	
	counter <- 0
	STOP=FALSE
	while(STOP==FALSE){
		counter <- counter+1
		for(constr in 1:length(bench)){
			# Calculate the constraint violations as a ratio of truth over estimate
			wt <- Y[[constr]]/(t(p.hat)%*%X[[constr]])
			# Set division by 0 to 0
			wt[which(is.nan(as.vector(as.matrix(wt))))]<-0
			# Update lagrange parameter
			theta[[constr]] <- theta[[constr]]+log(wt)
			# Update probabilities
			x.theta <- matrix(0,nrow=nrow(X[[1]]),ncol=nrow(Y[[i]]))
			for(i in 1:length(bench)){x.theta <- x.theta+X[[i]]%*%t(theta[[i]])}
			p.hat <- q*exp(x.theta)
			p.hat <- p.hat/sum(p.hat)
			}
		# Evaluate the maximum constraint violation
		diff <- NULL
		for(i in 1:length(bench)){ diff[i]<-max(abs(t(p.hat)%*%X[[i]]-Y[[i]]))}
		if(max(diff) < max.diff | counter>=max.counter) STOP=TRUE
		}
		if (counter>=max.counter){warning('max.entropy failed to converge')}
		return(list(p.hat=p.hat, theta=theta))
	}